unit Unit1;
http://www.phidels.com fait  partir d'un exemple fourni avec delphi.
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TForm1 = class(TForm)
  private
    //dclaration d'une procdure qui sera appele  chaque fois que form1
    // recevra le message WM_ENDSESSION
    procedure WMEndSession(var Msg:TWMEndSession); message WM_ENDSESSION;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
uses registry;

{$R *.DFM}

//L'exemple suivant dcrit comment demander  Windows de relancer votre application
//au dmarrage de Windows si elle tait en cours d'excution quand le systme
//a t arrt. Au dmarrage, Windows dmarre chaque application numre dans
//la cl RunOnce puis supprime l'entre pour cette application.

//Si votre poste se termine d'une faon anormale, le programmme ne sera donc pas relanc.
// Voir le composant RunOnce sur le site http://www.phidels.com plus facile  utiliser
// et qui fait redmarrer le programme mme s'il y a un crash

procedure TForm1.WMEndSession(var Msg: TWMEndSession);
// implmentation de la procdure qui sera dclench  chaqie message WM_ENDSESSION
// et donc  la fermeture de Windows
var
  Registre: TRegistry;
begin
  Registre := TRegistry.Create;
  try
    Registre.RootKey := HKEY_CURRENT_USER;
    if Registre.OpenKey('\Software\Microsoft\Windows\CurrentVersion\RunOnce', True)
    //dans la ligne suivante, NomApplication peut avantageusement tre remplac
    // par le nom de votre application de faon  viter qu'un autre programme
    // crase la donne dans la base de registre.
    then Registre.WriteString('NomApplication','"' + Application.ExeName + '"');
  finally
    Registre.CloseKey;
    Registre.Free;
    inherited;
  end;
end;

end.





 